// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package dictionary_mobile

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// MobileDbServiceClient is the client API for MobileDbService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type MobileDbServiceClient interface {
	GetDbVersion(ctx context.Context, in *GetDbVersionRequest, opts ...grpc.CallOption) (*GetDbVersionResponse, error)
	DownloadDb(ctx context.Context, in *DownloadDbRequest, opts ...grpc.CallOption) (*DownloadDbResponse, error)
	UploadDb(ctx context.Context, in *UploadDbRequest, opts ...grpc.CallOption) (*UploadDbResponse, error)
}

type mobileDbServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewMobileDbServiceClient(cc grpc.ClientConnInterface) MobileDbServiceClient {
	return &mobileDbServiceClient{cc}
}

func (c *mobileDbServiceClient) GetDbVersion(ctx context.Context, in *GetDbVersionRequest, opts ...grpc.CallOption) (*GetDbVersionResponse, error) {
	out := new(GetDbVersionResponse)
	err := c.cc.Invoke(ctx, "/fcp.dictionary.v1.dictionary_mobile.MobileDbService/GetDbVersion", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileDbServiceClient) DownloadDb(ctx context.Context, in *DownloadDbRequest, opts ...grpc.CallOption) (*DownloadDbResponse, error) {
	out := new(DownloadDbResponse)
	err := c.cc.Invoke(ctx, "/fcp.dictionary.v1.dictionary_mobile.MobileDbService/DownloadDb", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *mobileDbServiceClient) UploadDb(ctx context.Context, in *UploadDbRequest, opts ...grpc.CallOption) (*UploadDbResponse, error) {
	out := new(UploadDbResponse)
	err := c.cc.Invoke(ctx, "/fcp.dictionary.v1.dictionary_mobile.MobileDbService/UploadDb", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// MobileDbServiceServer is the server API for MobileDbService service.
// All implementations must embed UnimplementedMobileDbServiceServer
// for forward compatibility
type MobileDbServiceServer interface {
	GetDbVersion(context.Context, *GetDbVersionRequest) (*GetDbVersionResponse, error)
	DownloadDb(context.Context, *DownloadDbRequest) (*DownloadDbResponse, error)
	UploadDb(context.Context, *UploadDbRequest) (*UploadDbResponse, error)
	mustEmbedUnimplementedMobileDbServiceServer()
}

// UnimplementedMobileDbServiceServer must be embedded to have forward compatible implementations.
type UnimplementedMobileDbServiceServer struct {
}

func (UnimplementedMobileDbServiceServer) GetDbVersion(context.Context, *GetDbVersionRequest) (*GetDbVersionResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetDbVersion not implemented")
}
func (UnimplementedMobileDbServiceServer) DownloadDb(context.Context, *DownloadDbRequest) (*DownloadDbResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DownloadDb not implemented")
}
func (UnimplementedMobileDbServiceServer) UploadDb(context.Context, *UploadDbRequest) (*UploadDbResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UploadDb not implemented")
}
func (UnimplementedMobileDbServiceServer) mustEmbedUnimplementedMobileDbServiceServer() {}

// UnsafeMobileDbServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to MobileDbServiceServer will
// result in compilation errors.
type UnsafeMobileDbServiceServer interface {
	mustEmbedUnimplementedMobileDbServiceServer()
}

func RegisterMobileDbServiceServer(s grpc.ServiceRegistrar, srv MobileDbServiceServer) {
	s.RegisterService(&MobileDbService_ServiceDesc, srv)
}

func _MobileDbService_GetDbVersion_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetDbVersionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileDbServiceServer).GetDbVersion(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.dictionary.v1.dictionary_mobile.MobileDbService/GetDbVersion",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileDbServiceServer).GetDbVersion(ctx, req.(*GetDbVersionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileDbService_DownloadDb_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DownloadDbRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileDbServiceServer).DownloadDb(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.dictionary.v1.dictionary_mobile.MobileDbService/DownloadDb",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileDbServiceServer).DownloadDb(ctx, req.(*DownloadDbRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _MobileDbService_UploadDb_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UploadDbRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(MobileDbServiceServer).UploadDb(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.dictionary.v1.dictionary_mobile.MobileDbService/UploadDb",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(MobileDbServiceServer).UploadDb(ctx, req.(*UploadDbRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// MobileDbService_ServiceDesc is the grpc.ServiceDesc for MobileDbService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var MobileDbService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "fcp.dictionary.v1.dictionary_mobile.MobileDbService",
	HandlerType: (*MobileDbServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetDbVersion",
			Handler:    _MobileDbService_GetDbVersion_Handler,
		},
		{
			MethodName: "DownloadDb",
			Handler:    _MobileDbService_DownloadDb_Handler,
		},
		{
			MethodName: "UploadDb",
			Handler:    _MobileDbService_UploadDb_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "v1/dictionary_mobile/database.proto",
}
